/*
 * 活动奖励明细
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ActivityPrizeDetailController : BaseController
    {
        public ActivityPrizeDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 活动奖励明细列表

        /// <summary>
        /// 根据条件查询活动奖励明细列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ActivityPrizeDetail data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            List<KqProducts> Brands = db.KqProducts.OrderBy(m => m.Id).ToList();
            ViewBag.Brands = Brands;
            return View();
        }

        #endregion

        #region 根据条件查询活动奖励明细列表

        /// <summary>
        /// 活动奖励明细列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ActivityPrizeDetail data, string MakerCode, string RealName, string TopMakerCode, string TopRealName, string ActivityName, string TradeMonthSelect, string CheckStatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "0"); //产品类型

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopMakerCode))
            {
                condition += " and TopUserId in (select UserId from UserForMakerCode where MakerCode='" + TopMakerCode + "')";
            }
            //顶级创客名称
            if (!string.IsNullOrEmpty(TopRealName))
            {
                condition += " and TopUserId in (select UserId from UserForRealName where RealName='" + TopRealName + "')";
            }
            //活动名称
            if (!string.IsNullOrEmpty(ActivityName))
            {
                condition += " and ActivityId in (select ActivityId from ProfitObjectsActivesForId where Name='" + ActivityName + "')";
            }
            //交易月份
            if(!string.IsNullOrEmpty(TradeMonthSelect))
            {
                condition += " and TradeMonth=" + TradeMonthSelect.Replace("-", "");
            }
            //同步状态
            if(!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ActivityPrizeDetail", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ActivityName"] = RelationClass.GetProfitObjectsActivesInfo(int.Parse(dic["ActivityId"].ToString()));
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                if (!string.IsNullOrEmpty(user.ParentNav))
                { 
                    int TopId = int.Parse(user.ParentNav.Trim(',').Replace(",,", ",").Split(',')[0]);
                    Users tuser = db.Users.FirstOrDefault(m => m.Id == TopId) ?? new Users();
                    dic["TopMakerCode"] = tuser.MakerCode;
                    dic["TopRealName"] = tuser.RealName;
                }
                dic["CheckStatus"] = dic["CheckStatus"].ToString() == "1" ? "已验证和同步" : "初始";
            }
            return Json(obj);
        }

        #endregion

        #region 增加活动奖励明细

        /// <summary>
        /// 增加或修改活动奖励明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加活动奖励明细

        /// <summary>
        /// 增加或修改活动奖励明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ActivityPrizeDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ActivityPrizeDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "ActivityPrizeDetail", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改活动奖励明细

        /// <summary>
        /// 增加或修改活动奖励明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            ActivityPrizeDetail editData = db.ActivityPrizeDetail.FirstOrDefault(m => m.Id == Id) ?? new ActivityPrizeDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改活动奖励明细

        /// <summary>
        /// 增加或修改活动奖励明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ActivityPrizeDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityPrizeDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "ActivityPrizeDetail", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除活动奖励明细信息

        /// <summary>
        /// 删除活动奖励明细信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ActivityPrizeDetail", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityPrizeDetail", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ActivityPrizeDetail", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityPrizeDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ActivityPrizeDetail", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ActivityPrizeDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ActivityPrizeDetail", Sort, Id);

            AddSysLog(Id.ToString(), "ActivityPrizeDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.ActivityPrizeDetail.Add(new ActivityPrizeDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "ActivityPrizeDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ActivityPrizeDetail data, string MakerCode, string RealName, string TopMakerCode, string TopRealName, string ActivityName, string CheckStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "0"); //产品类型
            Fields.Add("TradeMonth", "1"); //交易月份

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopMakerCode))
            {
                condition += " and TopUserId in (select UserId from UserForMakerCode where MakerCode='" + TopMakerCode + "')";
            }
            //顶级创客名称
            if (!string.IsNullOrEmpty(TopRealName))
            {
                condition += " and TopUserId in (select UserId from UserForRealName where RealName='" + TopRealName + "')";
            }
            //活动名称
            if (!string.IsNullOrEmpty(ActivityName))
            {
                condition += " and ActivityId in (select ActivityId from ProfitObjectsActivesForId where Name='" + ActivityName + "')";
            }
            //同步状态
            if(!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ActivityPrizeDetail", Fields, "Id desc", "0", 1, 20000, condition, "UserId,ActivityId,BrandId,TradeMonth,TradeAmt,CreditTradeAmt,ActRewardAmt,OtherProdCreditTradeAmt,ProfitRate,CheckStatus", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ActivityName"] = RelationClass.GetProfitObjectsActivesInfo(int.Parse(dic["ActivityId"].ToString()));
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                if (!string.IsNullOrEmpty(user.ParentNav))
                { 
                    int TopId = int.Parse(user.ParentNav.Trim(',').Replace(",,", ",").Split(',')[0]);
                    Users tuser = db.Users.FirstOrDefault(m => m.Id == TopId) ?? new Users();
                    dic["TopMakerCode"] = tuser.MakerCode;
                    dic["TopRealName"] = tuser.RealName;
                }
                dic["CheckStatus"] = dic["CheckStatus"].ToString() == "1" ? "已验证和同步" : "初始";
                dic.Remove("ActivityId");
                dic.Remove("UserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客姓名");
            ReturnFields.Add("ActivityName", "活动名称");
            ReturnFields.Add("TopMakerCode", "顶级创客编号");
            ReturnFields.Add("TopRealName", "顶级创客名称");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("TradeMonth", "交易月份");
            ReturnFields.Add("TradeAmt", "团队交易总金额(元)");
            ReturnFields.Add("CreditTradeAmt", "团队贷记卡交易总金额(元)");
            ReturnFields.Add("ActRewardAmt", "团队交易活动奖励金额(元)");
            ReturnFields.Add("OtherProdCreditTradeAmt", "其他产品贷记卡交易总金额(元)");
            ReturnFields.Add("ProfitRate", "活动奖励对应分成比例(万)");
            ReturnFields.Add("CheckStatus", "同步状态");
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ActivityPrizeDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
